<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="公司名" prop="companyId">
          <el-select filterable style="width: 220px" v-model="queryParams.companyId" placeholder="请选择公司名" clearable size="small">
              <el-option
                v-for="item in companys"
                :key="item.companyId"
                :label="item.companyName"
                :value="item.companyId"
              />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['company:companyVoice:add']"
        >充值</el-button>
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['company:companyVoice:export']"
        >导出</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table  height="500" border v-loading="loading" :data="companyVoiceList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="voiceId" />
      <el-table-column label="公司" align="center" prop="companyName" />
      <el-table-column label="总时长 (分)" align="center" prop="totalTimes" />
      <el-table-column label="使用时长 (分)" align="center" prop="useTimes" />
      <el-table-column label="剩余时长 (分)" align="center" prop="times" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改企业通话对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="公司" prop="companyId">
          <el-select style="width: 320px" v-model="form.companyId" placeholder="请选择公司" clearable size="small">
            <el-option
              v-for="item in companys"
              :key="item.companyId"
              :label="item.companyName"
              :value="item.companyId"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="通话套餐" prop="packageId">
          <el-select style="width: 320px" v-model="form.packageId" placeholder="请选择套餐" clearable size="small">
            <el-option
              v-for="item in allVoicePackageData"
              :key="item.packageId"
              :label="item.packageName"
              :value="item.packageId"
            />
          </el-select>
        </el-form-item>
<!--        <el-form-item label="剩余时长 分" prop="times">-->
<!--          <el-input v-model="form.times" placeholder="请输入剩余时长 分" />-->
<!--        </el-form-item>-->
<!--        <el-form-item label="累计时长 分" prop="totalTimes">-->
<!--          <el-input v-model="form.totalTimes" placeholder="请输入累计时长 分" />-->
<!--        </el-form-item>-->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm" :disabled="buyBtnDisable">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listCompanyVoice,
  getCompanyVoice,
  updateCompanyVoice,
  exportCompanyVoice,
  companyBuyVoice
} from "@/api/company/companyVoice";
import {listAllCompanyVoicePackage} from "@/api/company/companyVoicePackage";
import { getCompanyList } from "@/api/company/company";
export default {
  name: "CompanyVoice",
  data() {
    return {
      companys:[],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      buyBtnDisable: false,
      // 总条数
      total: 0,
      // 企业通话表格数据
      companyVoiceList: [],
      allVoicePackageData: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        companyId: null,
        times: null,
        totalTimes: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    getCompanyList().then(response => {
      this.companys = response.data;

    });
    listAllCompanyVoicePackage({status:1}).then(response => {
      this.allVoicePackageData = response.data;
    });
  },
  methods: {
    /** 查询企业通话列表 */
    getList() {
      this.loading = true;
      listCompanyVoice(this.queryParams).then(response => {
        this.companyVoiceList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        companyId: null,
        packageId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.voiceId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加企业通话";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const voiceId = row.voiceId || this.ids
      getCompanyVoice(voiceId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改企业通话";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.buyBtnDisable = true
          companyBuyVoice(this.form).then(response=>{
            if (response.code === 200) {
              this.msgSuccess("充值成功");
              this.open = false;
              this.getList();
            }
          }).catch(err=>{
            this.msgError(err.message)
            this.open = false
          }).finally(()=>{
            this.reset();
            setTimeout(()=>{
              this.buyBtnDisable = false
            },1000)
          })
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const voiceIds = row.voiceId || this.ids;
      this.$confirm('是否确认删除企业通话编号为"' + voiceIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delCompanyVoice(voiceIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有企业通话数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportCompanyVoice(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    }
  }
};
</script>
